<?php
/* Print the info for thumb navigation (go to previous/next) */
function get_thumb ($gallery, $snimek, $text, $alt) {
	global $root, $show_thumbs;
	$PHP_SELF = $_SERVER["PHP_SELF"];

	$path = "$root/$gallery/thumbs";

	if ($show_thumbs) {
		$if_show_thumbs = "&show_thumbs=$show_thumbs";
	}

	if (is_file("$root/$gallery/lq/img-$snimek.png")) {
		$thumb = "$gallery/thumbs/img-$snimek.png";
		$v = getimagesize($thumb);
		$img = "<a href=\"$PHP_SELF?gallery=$gallery&snimek=$snimek" .
			     "$if_show_thumbs\">" .
				 "<img alt=\"$alt\" src=\"$thumb\" ${v[3]} /></a>";
		$text = "[ <a href=\"$PHP_SELF?gallery=$gallery&snimek=$snimek" .
			     "$if_show_thumbs\">$text</a> ]";

		$size = filesize ("$root/$gallery/lq/img-$snimek.png");
		$size = sprintf ("%d KB", $size / 1024);
	}
	return array ($text, $img, $size);
}

/* Read the comment's file for snimek */
function get_comment ($gallery, $snimek) {
	
	$comment = "$gallery/comments/$snimek.txt";

	if (file_exists ($comment)) {
		$cmnt_array = file ($comment);

		foreach ($cmnt_array as $x) {
			$cmnt .= $x;
		}
	}
	return $cmnt;
}

function get_zipped ($gallery) {
	if (file_exists ("$gallery/zip/mq.zip")) {
		$zipped .= "[ <a href=\"$gallery/zip/mq.zip\">" . 
				   _("zipped MQ images") . "</a> ] ";
	}
	if (file_exists ("$gallery/zip/mq.tar.bz2")) {
		$zipped .= "[ <a href=\"$gallery/zip/mq.tar.bz2\">" .
				   _("MQ images tarball") . "</a> ] ";
	}
	if (file_exists ("$gallery/zip/hq.zip")) {
		$zipped .= "[ <a href=\"$gallery/zip/hq.zip\">" .
				   _("zipped HQ images") . "</a> ]";
	}
	if (file_exists ("$gallery/zip/hq.tar.bz2")) {
		$zipped .= "[ <a href=\"$gallery/zip/hq.tar.bz2\">" .
				   _("HQ images tarball") . "</a> ]";
	}
	return $zipped;
}

/* Get the link to medium quality image and its size information in
   kilobytes */
function get_info_mq ($gallery, $snimek) {

	$file = "$gallery/mq/img-$snimek.png";
	if (file_exists ($file)) {
		$size = sprintf ("%d KB", filesize ($file) / 1024);
		$link = "<a href=\"$file\">" . _("MQ") . "</a>";
	}
	return array ($link, $size);
}

/* Get the link to high quality image and its size information in
   kilobytes */
function get_info_hq ($gallery, $snimek) {

	$file = "$gallery/hq/img-$snimek.jpg";
	if (file_exists ($file)) {
		$size = sprintf ("%d KB", filesize ($file) / 1024);
		$link = "<a href=\"$file\">" . _("HQ") . "</a>";
	}
	return array ($link, $size);
}

function check ($file) {
   global $root;
   
   if (eregi("[^0-9a-z\_\-\ ]",$file) || !file_exists("$root/$file")) {
      echo _("Bad input");
   }
}

?>
