<?php
function print_general ($adr) {
   global $excluded_dirs;

   echo "<ul>\n";
   while ($file = $adr->read()) {
      if (is_dir($file) && !ereg("\.", $file) && 
	  	!in_array ($file, $excluded_dirs)) {

		 if ($file != "video") {
			 echo "<li><a href=\"" .  $_SERVER["PHP_SELF"] . 
			 	  "?gallery=$file\">$file</a>";
		 } else {
			 echo "<li><a href=\"$file/\">$file</a>";
		 }
         echo "<div class=\"date\">";
         if ($date_format == "ISO8601") {
            echo strftime("%Y-%m-%d", filemtime($file));
         } else {
            echo strftime("%d %b %Y", filemtime($file));
         }
         echo "</div></li>\n";
      }
   }
   echo "</ul>\n";
}

function get_thumbnails ($root, $gallery) {
   //thumbnails
   $path = "$root/$gallery/thumbs";
   $folder = dir ($path);
   check ($gallery);

   $thumbs = array ();
   $i = 0; 
   while ($file = $folder->read ()) {
      if (is_file("$path/$file") && eregi("^img-([0-9]+)\.png", $file, $x)) {
         $thumb = "$gallery/thumbs/img-${x[1]}.png";
         $image_info = getimagesize ($thumb);
         $id = sprintf ("%s", "${x[1]}");
		 
		 array_push ($thumbs, array ("file" => $thumb,
		 							 "info" => $image_info,
									 "id"   => $id));
	  }
   }
   return ($thumbs);
}

function list_thumbnails ($thumbs, $gallery) {
	$php_self = $_SERVER["PHP_SELF"];

	foreach ($thumbs as $val) {
		$id = $val["id"];
		$file = $val["file"];
		$info = $val["info"];
		$ref = "<a href=\"$php_self?gallery=$gallery" .
			   "&snimek=$id\">" .
			   "<img border=\"0\" src=\"$file\"" .
			   " alt=\"" . sprintf (_("photo No. %s"), $id) . 
			   "\" $info[3] /></a>\n";
		echo $ref;
	}
}

function get_image ($root, $gallery, $snimek) {
	$path = "$root/$gallery/thumbs";
	$folder = dir($path);
	check($gallery);
	$path = "$gallery/lq";
	$file = "$path/img-$snimek.png";
	if (!file_exists ($file)) {
		echo _("No such image");
		return;
	}
	$info = getimagesize ($file);

	return "<img ${info[3]} src=\"$file\" alt=\"$snimek\" />";
}

function show_thumbs ($root, $gallery, $snimek) {
	global $mini_thumb_ratio, $img;

	$show_thumbs = $_GET["show_thumbs"];
	$PHP_SELF = $_SERVER["PHP_SELF"];

   $path = "$root/$gallery/thumbs";
   $folder = dir($path);
   check($gallery);

   if ($show_thumbs) {
		echo "\n<p class=\"navigation\">";
		echo "<a href=\"$PHP_SELF?gallery=$gallery&snimek=$snimek\">";
		echo "<img alt=\"-\" src=\"". $img["minus"] . "\" width=\"16\" ";
		echo "height=\"16\" align=\"middle\" border=\"0\">";
		echo "</a> : ";
		while ($thumbfile = $folder->read()) {
			if ( eregi("^img-([0-9]+)\.png", $thumbfile, $x)) {
				$thumb = "$gallery/thumbs/img-${x[1]}.png";
				echo "<a href=\"$PHP_SELF?gallery=$gallery&snimek=${x[1]}";
				echo "&show_thumbs=$show_thumbs\">";
				echo "<img align=\"middle\" class=\"thumb\" border=\"0\"";
				// hadess' hack (TM) ;)
				// FIXME: $thumbsize is not working yet
				if ($thumbsize) {
					 echo " width=\"24\" height=\"16\"";
				} else {
					$minithumb = getimagesize ($thumb);
					echo $mini_thumb_ratio;
					$w = $minithumb[0] * $mini_thumb_ratio;
					$h = $minithumb[1] * $mini_thumb_ratio;
					echo " width=\"$w\" height=\"$h\"";
				}
				echo " src=\"$thumb\" ";
				echo "alt=\"" . sprintf (_("photo No. %s\">"), "${x[1]}");
				echo "</a> ";
			}
		}
		echo "</p>";
	} else {
		/* Show only the [+] button to enable show all mini thumbnails */
		echo "<a href=\"$PHP_SELF?gallery=$gallery&snimek=$snimek";
		echo "&show_thumbs=yes\">";
		echo "<img alt=\"-\" src=\"" . $img["plus"] . "\" width=\"16\" ";
		echo " align=\"middle\" height=\"16\" border=\"0\"";
		echo " style=\"border: 0px;\">";
		echo "</a>\n";
		echo "</p>\n";
	}
}

/* Print the info for thumb navigation (go to previous/next) */
function get_thumb ($gallery, $snimek, $nav_text, $alt) {
	global $root, $show_thumbs;
	$PHP_SELF = $_SERVER["PHP_SELF"];

	$path = "$root/$gallery/thumbs";

	if ($show_thumbs) {
		$if_show_thumbs = "&show_thumbs=$show_thumbs";
	}

	if (is_file("$root/$gallery/lq/img-$snimek.png")) {
		$thumb = "$gallery/thumbs/img-$snimek.png";
		$v = getimagesize($thumb);
		$img = "<a href=\"$PHP_SELF?gallery=$gallery&snimek=$snimek" .
			     "$if_show_thumbs\">" .
				 "<img alt=\"$alt\" src=\"$thumb\" ${v[3]} /></a>";
		$text = "[ <a href=\"$PHP_SELF?gallery=$gallery&snimek=$snimek" .
			     "$if_show_thumbs\">$nav_text</a> ]";

		$size = filesize ("$root/$gallery/lq/img-$snimek.png");
		$size = sprintf ("%d KB", $size / 1024);
	}
	return array ($text, $img, $size);
}

/* Read the comment's file for snimek */
function get_comment ($gallery, $snimek) {
	
	$comment = "$gallery/comments/$snimek.txt";

	if (file_exists ($comment)) {
		$cmnt_array = file ($comment);

		foreach ($cmnt_array as $x) {
			$cmnt .= $x;
		}
	}
	return $cmnt;
}

function get_zipped ($gallery) {
	if (file_exists ("$gallery/zip/mq.zip")) {
		$zipped .= "[ <a href=\"$gallery/zip/mq.zip\">" . 
				   _("zipped MQ images") . "</a> ] ";
	}
	if (file_exists ("$gallery/zip/mq.tar.bz2")) {
		$zipped .= "[ <a href=\"$gallery/zip/mq.tar.bz2\">" .
				   _("MQ images tarball") . "</a> ] ";
	}
	if (file_exists ("$gallery/zip/hq.zip")) {
		$zipped .= "[ <a href=\"$gallery/zip/hq.zip\">" .
				   _("zipped HQ images") . "</a> ]";
	}
	if (file_exists ("$gallery/zip/hq.tar.bz2")) {
		$zipped .= "[ <a href=\"$gallery/zip/hq.tar.bz2\">" .
				   _("HQ images tarball") . "</a> ]";
	}
	return $zipped;
}

/* Get the link to medium quality image and its size information in
   kilobytes */
function get_info_mq ($gallery, $snimek) {

	$file = "$gallery/mq/img-$snimek.png";
	if (file_exists ($file)) {
		$size = sprintf ("%d KB", filesize ($file) / 1024);
		$link = "<a href=\"$file\">" . _("MQ") . "</a>";
	}
	return array ($link, $size);
}

/* Get the link to high quality image and its size information in
   kilobytes */
function get_info_hq ($gallery, $snimek) {

	$file = "$gallery/hq/img-$snimek.jpg";
	if (file_exists ($file)) {
		$size = sprintf ("%d KB", filesize ($file) / 1024);
		$link = "<a href=\"$file\">" . _("HQ") . "</a>";
	}
	return array ($link, $size);
}

function check ($file) {
   global $root;
   
   if (eregi("[^0-9a-z\_\-\ ]",$file) || !file_exists("$root/$file")) {
      echo _("Bad input");
   }
}
